import serial
import time

#Linux Port = '/dev/ttyACM0'
#Windows = 

def connect(port = 'COM6', baudrate=9600):
    s = serial.Serial(port,baudrate)
    waitMessage(s,'Enter design parameters',matchMessage='Yes')
    waitMessage(s,'Enter data in this style <motortime (milliseconds), stoptime (milliseconds), motorpwm (0-255), stoppwm (0-255)>',matchMessage='Yes')
    return s

#Sends a set of Commands to the Motor.
def sendCommand(connection,motorTime,motorPwm,stopTime,stopPwm):
    commandStr = "<"+str(motorTime)+","+str(stopTime)+","+str(motorPwm)+","+str(stopPwm)+">"+"\r\n"
    connection.write(commandStr.encode('utf-8'))

#Takes in Serial Connection, the string we're looking for the microcontroller to return
#a message we want to say to the user when we recieve the message (Can be None)
#How long to wait before looking for the response, and a debug to print all communications
def waitMessage(connection,matchString,matchMessage = None,delay = 2,debug = False):
    time.sleep(delay)
    #While there are messages in the buffer, parse them
    while connection.inWaiting() > 0:
        line = connection.readline()
        #Printing if we're debugging
        if debug:
            print(line)
        #Matching our Line against the Return
        if line == matchString:
            if matchMessage:
                print(matchMessage)
    return

if __name__ == "__main__":
    serialConnection = connect()
    sendCommand(serialConnection, 25,225,100,255)
    serialConnection.close()
    pass